(*                        POZDRAVY pana TAYLORA :-)
                        ~~~~~~~~~~~~~~~~~~~~~~~~~
                            x
1. vytvorte tabulku funkce e , pro x ze zadaneho intervalu [-m,m].
   zadavane hodnoty :                         x
   - m : rozsah intervalu pro vypocet hodnot e
   - k : konstanta - dany pocet desetinnych mist - pro vypocet hodnoty eps
........................................................................
   - tabulkove hodnoty zobrazujte po kroku 1
   - k vypoctu pouzijte Tayloruv rozvoj dany vzorcem :

                         2           n
	 x        x     x           x
	e  = 1 + --- + --- + ... + ---  pro x z intervalu [-m,m]
                  1!    2!          n!
........................................................................
   POZNAMKY k reseni :
   - opet algoritmus dany nejakym iteracnim/rekurentnim vztahem
   - pocitame jednotlive castecne soucty
            s(i) = c0 + c1 + ... + ci
     tak dlouho, dokud neplati, ze :
            abs ( s(i+1) - s(i) ) < eps  - coz v dusledku znamena,
     dokud        c(i+1)          < eps

   - z definicniho rozvoje plyne
     (podil dvou sousednich scitancu = koeficient geometricke posloupnosti),
     ze jednotlive c(i) jsou dany iteracnim/rekurentnim vztahem

     c(0) = 1
                      x
     c(i) = c(i-1) * ---  pro i=1,2,..=> jednotlive castecne soucty jsou tvaru :
                      i
     s(0) = 1
                 x
     s(1) = 1 + ---
                 1!
                        2
	         x     x
     s(2) = 1 + --- + ---
                 1!    2!

   - priklad je pozadovan k zapoctu
   - konkretni navod - schema programu pro e^x viz euler.pas
============================================================================

2. vytvorte tabulku hodnot funkce sin(x) ,
   pro x z intervalu [0,2*pi] s presnosti danou opet spoctenou konstantou
   ze zadavaneho poctu desetinnych mist
........................................................................
   - tabulkove hodnoty zobrazujte po kroku 10-ti stupnu = pi/18
   - k vypoctu pouzijte Tayloruv rozvoj dany vzorcem :

                      3                   2n-1
	       x     x              n-1  x
    sin(x) =  --- - --- + ... + (-1)  . --------  pro x z intervalu [0,2*pi]
               1!    3!                  (2n-1)!

    kde c(i) jsou dany iteracnim/rekurentnim vztahem
              x
      c(1) = ---
              1!                         2
                           i-1          x
      c(i) = c(i-1) *  (-1)    * ---------------       pro i = 2,3,...
                                 (2*i-1)*(2*i-2)

   - hodnota x je ve vzorcich uvazovana v radianech
   - pozor pri programovani vlastniho vypocetniho vzorce na chybny primy vypocet
     mocniny x a faktorialu n v nejake promenne, kdy nutne dojde k preteceni pocitane 
     hodnoty i pri volbe nejvetsich rozsahu. Obe hodnoty se defakto objevi pokracene 
     pri spravnem vypoctu iterace ci.
   - priklad je pozadovan k zapoctu
----------------------------------------------------------------------------
 - obe dve tabulky prehledne zobrazte
 - vypocet mocniny x v citateli a faktorialu ve jmenovateli v definicnim
   vzorci se NEREALIZUJE zvlastnim vypoctem (kuprikladu fci nebo procedurou),
   pro kazdou mocninu nebo faktorial, ale POSTUPNYM NASOBENIM pomocne
   promenne ci patricne aktualizovanou hodnotou.
 - snazte se psat kod programu blokove, tzn. s vyhledem na pozdejsi prepsani
   jednotlivych casti programu (nacteni vstupnich hodnot,
   vlastni vypocet/vypocty, zobrazeni vysledku, popripade tisk tabulky)
   na procedury/funkce.
   Tento postup Vas donuti dodrzovat pravidlo
   jednoho vstupu a vystupu pro kazdy blok (cast programu)
==========================================================================

  NAMETY NA VOLNOU TVORBU - pro procviceni - nejsou pozadovany k zapoctu

  - setridte tri zadane hodnoty A,B,C podle velikosti

  - spoctete n-te Fibonacciho cisla, dane iteracnim vzorcem :
    a0 = 0; a1 = 1; ai+2 = ai+1 + ai; pro i = 2,3,..,n

  - spoctete eulerovo cislo s presnosti na ??? 20 ??? desetinnych mist
    dle Taylorova vzorce :

                  1     1     1
	e  = 1 + --- + --- + --- + ...
                  1!    2!    3!


  - realizujte vypocet vnitrnich uhlu trojuhelnika ve stupnich,minutach,sekundach
    ze zadanych delek stran - viz soubor trojuh.pas

*)