(* =======================================================================
   dnesni tema : tridici a vyhledavaci metody
   - zkuste sami navrhnout :
   -- na vstupu mate libovolnou posloupnost nezapornych cisel, jak se
      dopracujete k jeji setridene podobe ?


   =======================================================================

   zakladni metody trideni

   1. - bublinova metoda -
   -----------------------------------------------------------------------
   1.1 - bez rozpoznani setrideneho pole- bubble1.pas
   serazuji vzestupne
   porovnam dva sousedni prvky - prvni je vetsi - prohodim
   pokracuji dalsi dvojici
   45 23 15 68 94        23 15 45 68 94   15 23 45 68 94   15 23 45 68 94
   23 45 15 68 94        15 23 45 68 94   15 23 45 68 94
   23 15 45 68 94        15 23 45 68 94
   23 15 45 68 94

   takze pro program dva vnorene cykly
   for i:=n downto 2
       for j:=2 to i do ...prace s prvky a[j-1] a[j]...

   pri dalsich prubezich nebylo jiz nutne az do konce nektere dvojice
   prohazovat - zbytek posloupnosti byl jiz setrideny
   => nemohl bych algoritmus ukoncit = urychlit ?,
      cili pamatovat si pri predchozim prubehu, ze uz nebylo co tridit ?

   1.2 - s rozpoznani setrideneho pole - bubble2.pas
   pamatuji si index 3 - index posledni vymeny
   dalsi srovnavani delam uz jen do tohoto indexu
             45 23 15 68 94        15 23 45 68 94
             23 45 15 68 94        15 23 45 68 94
             23 15 45 68 94
             23 15 45 68 94
   nutno zmenit jeden cyklus for na jiny diky zmene ridici promenne cyklu
   uvnitr tohoto cyklu

   =======================================================================
   2. trideni vyberem  - nepozna setridene pole
   -----------------------------------------------------------------------
   serazuji sestupne
   z dane posloupnosti vybereme nejvetsi prvek
   vymenime jej s aktualnim indexem
   45 23 15 68 94      ....    prohozeni 45 s 94
   94 23 15 68 45              atd.
   94 68 15 23 45
   94 68 45 23 15
   94 68 45 23 15

   =======================================================================
   3. Shellovo trideni - trideni vkladanim se zmensovaim kroku
   -----------------------------------------------------------------------
   - metoda tridici postupne jednotlive prvky vzdalene od sebe k pozic
   -- volba vhodneho k je predmetem diskuze
   -- pro demonstraci volme krok k postupne odpovidajici tomuto prikazu
      k:=k div 2;

   - puvodni posloupnost

     44   55   12   42   94   18   06   67      prvni krok k=4
     porovnavam 44 - 94; 55 - 18; ...
     dostavam :

     44   18   06   42   94   55   12   67      druhy krok k=2, dostavam

     06   18   12   42   44   55   94   67      treti krok k=1, dostavam

     06   12   18   42   44   55   67   94      jiz setridenou posloupnost


   -- vhodnejsi volba kroku k muze zlepsit vyslednou slozitost
      napriklad pro hodnoty kroku k davajici tuto posloupnost :

      1, 4, 13, 40, 121, ...
      h[k-1] = 3h[k] + 1,  h[t] = 1   a   t = trunc(log n) - 1
                                                       3
      nebo

      1, 3, 7, 15, 31, ...
      h[k-1] = 2h[k] + 1,  h[t] = 1   a   t = trunc(log n) - 1
                                                       2

                                                     1,2
      slozitost druhe posloupnosti volby kroku k je n

   - podrobnosti viz Niklaus Wirth : Algoritmy a struktury udajov
                     - slovensky preklad
   =======================================================================
   4. trocha hledani ... - opet otazky :
      - jak v libovolne posloupnosti najit nejrychleji :
      -- maximalni (minimalni, k-ty v poradi) prvek.
      - v usporadane posloupnosti prvek zadane hodnoty.

   binarni hledani - hledani metodou puleni intervalu
   - v setridene posloupnosti prvku najdete index prvku zadane hodnoty
   -----------------------------------------------------------------------
   na vstupu setridena posloupnost, hledam index prvku dane hodnoty
   v pomocnych promennych uchovan dolni a horni index aktualne
   prohledavaneho pole - casti pole
   cyklus
    pomoci div najdu prostredni prvek pole
    porovnam prostredni prvek s hledanou hodnotou
    jestlize jsou ruzne, pak
      jestlize je prostredni vetsi nez hledany prvek,
          pak zmena horniho indexu na hodnotu prostredniho
          jinak zmena dolniho indexu
   cyklus konci pokud hodnota prostredniho prvku je rovna hledane hodnote

   viz binfind.pas

   =======================================================================
   nalezeni minimalni a maximalni hodnoty z nesetridene posloupnosti prvku
   metodou se slozitosti 3n/2 - 2
   -----------------------------------------------------------------------
   - hledani metodou prvniho napadu
   --------------------------------
   -- prohledavam postupne vsechny prvky posloupnosti a kazdy srovnavam
      s pomocnou promennou maxima a minima
      => 2*n srovnani, pripadne prirazeni hodnoty pomocne promenne
   - efektivnejsi metoda - metoda predsrovnani dvou sousednich prvku
   -----------------------------------------------------------------
   -- v kazdem kroku porovnam vzdy nejprve dva sousedni prvky navzajem
   -- nasledne mensi z nich srovnavam s minimem a
               vetsi z nich s maximem
   -- pokracuji s krokem i:=i+2
      => usetrim - ze ctyr porovnani pro kazde i dostavam
                   jen tri vzdy pro kazdou dvojici => 3*n/2 srovnani
   - nutno rozmyslet, jak vhodne nalozit s lichym poctem prvku v posloupnosti
     (vhodne prevest na sudy pocet)

   ===========================================================================
   Nalezeni n-teho prvku nesetridene posloupnosti
      - viz soubor median.pas
   ===========================================================================
   5. vlastni prace :
      - otestovat prilozene programy nejlepe v krokovacim rezimu se zobrazenim
        promennych v okne watches

   ukoly k zapoctu :
      - program pro nalezeni minima a maxima z dane posloupnosti prvku
        se slozitosti 3n/2 - 2 ze zadani uvedeneho vyse nebo na webu ci
        na prednasce
      - naprogramovat dle vlastni volby nerekurzivni tridici metodu
        (krome metod primo uvedenych v programech na cviceni - bublesort)
        uvedenou v literature, na prednasce, na webu i dle vlastniho napadu
        k odevzdavanemu reseni uvest :
        ==============================
        - nazev zvolene tridici metody
        - strucny popis algoritmu trideni + vas odhad jeho slozitosti
        - vlastni fungujici program s postupnymi kontrolnimi vypisy castecne
          setrideneho pole po jednotlivych prubezich vnitrnich cyklu

      - literatura - standardne :
        - Algoritmy a struktury udajov - Niklaus Wirth - slovensky preklad

   NAPADY k vlastni tvorbe
   - vhodne zkombinovat vyse uvedene metody (trideni vyberem minima, maxima)
     s nalezenim minimalniho a maximalniho prvku dane posloupnosti
     a tridit soucasne od zacatku i od konce trideneho pole
   - zkusit pouzit algoritmus vyberu k-teho prvku a jeho umisteni
     na k-tou pozici
     - nasledne prehazet vuci takto stanovenemu pivotu prvky nalevo vetsi
       s prvky napravo mensimi (pro vzestupne trideni)
       a zvlast tridit horni a dolni polovinu takto rozdeleneho pole.
