{  strucny navod pro stavbu vlastni unity - programove jednotky - z jiz
   napsanych kratkych programu-procedur/funkci

   - pouziti teto jednotky viz soubor my_proc.pas
}

unit my_unit;  { - jmeno unity a jmeno souboru se zdrojovym textem
                   teto unity ulozenym na disku se musi shodovat
                   cili na disku musi existovat soubor
                   my_unit.pas
                 - po prekladu hlavniho programu se na disku vytvori soubor
                   my_unit.tpu
                 - preklad unity lze provest samostatne (F9) nebo
                   se provede automaticky v ramci prekladu hlavniho programu
                   (samostatny preklad jednotky jeste nevytvori soubor .tpu)
               }

interface      { - kouzelne slovicko - sekce verejnych deklaraci a definic
                   - const, type, var,
                   - function, procedure (pouze hlavicky vcetne parametru)
                   viditelnych a pouzitelnych z vnejsku
                   - na vse, co uvedu odsud az po kouzelne slovicko
                     implementation se budu moci odvolavat z hlavniho programu,
                     pokud v nem bude uvedeno uses my_unit;

                 - v cele teto sekci _MOHU_ pouzit veskere deklaracni
                   struktury pascalu - const, type, var
                   uplne stejne jako je pouzivam v hlavnim programu
                 - vzhledem k tomu, ze budou z hlavniho programu viditelne
                   nemusim je jiz v hl.programu deklarovat

                 - predevsim zde vsak uvadim _POUZE_HLAVICKY_
                   nize dodefinovanych funkci a procedur
                   (samozrejme jen tech, u kterych budu pozadovat vyuziti
                   dalsimi programy)
                 - poradi hlavicek se sice nemusi shodovat
                   s poradim nize uvedenych kodu proc/fci,
                   je to vsak vhodnejsi
                 - shoda vlastnich hlavicek je vsak samozrejma
               }

type vstupy = longint;

var x,n,i : vstupy;
    eps,a,xi,xj : real;

function exponent(x,y : vstupy) : real;
function OK_prvoc ( x : vstupy) : boolean;
procedure Newton(eps,poc : real; var a,b : real; var i : vstupy);

implementation { - kouzelne slovicko uvozujici interni deklarace a definice
                   - uses, const, type, var,
                   - function, procedure
                     - dodefinovane funkce a procedury ze sekce interface
                     - staci hlavicky bez parametru,
                       je vsak prehlednejsi/citelnejsi uvadet kompletni
                       hlavicky i zde
                 - vse dalsi (krom dodefinovanych funkci a procedur,
                   jejichz hlavicky byly uvedeny v sekci interface)
                   lze pouzit _POUZE_ pro tuto unitu
                   (samozrejme unita muze mit nektere dalsi pomocne
                    programove prostredky, jez verejne proc/fce budou
                    vyuzivat, ale tyto jiz z vnejsku (v hlavnim programu)
                    nebudou pouzitelne
               }
function exponent(x,y : vstupy) : real;
begin exponent:=exp(y*ln(x));
end;

function OK_prvoc ( x : vstupy) : boolean;
var n : vstupy;
begin n:=2;
      while (x mod n <> 0) and (n<=trunc(sqrt(x)))  do inc(n);
      if n>trunc(sqrt(x)) then OK_prvoc:=true
                          else OK_prvoc:=false;
end;

procedure Newton(eps,poc : real; var a,b : real; var i : vstupy);
begin b:=poc; i:=0;
      repeat a := b;
             b := 1/2 * (a + poc/a);
             i := i+1;
      until abs(b-a) < eps;
end;


{...........................................................
 begin       - kazda unita muze _ALE NEMUSI_ mit inicializacni kod
             - prostor pro nastaveni pocatecnich hodnot, parametru
               nejruznejsiho charakteru, hodnoty libovolnych
               datovych struktur, otevrit prislusne soubory... apod
               napr. ve standardni jednotce Pascalu Crt jsou v inicializacni
               casti tyto prikazy :
                AssignCrt(Input); Reset(Input);
                - inicializace standartniho vstupu
                AssignCrt(Output); Reset(Output);
                - inicializace standartniho vystupu
               - diky temto prikazum nemusite pri pouziti standardnich
                 prikazu vstupu a vystupu read/write, readln/writeln,
                 specifikovat odkud/kam mate nacitat/vypisovat
                 cili napr pisete pouze readln(a); writeln(a);
                 namisto readln(f,a); writeln(g,a);
                 jak byste psali pri praci s vami deklarovanymi soubory
             - tato cast vcetne begin _NENI_ povinna
 ...........................................................
}
 end.      { - ukonceni unity - _JE_ povinne i kdyz chybi predesle begin
             - pouziti teto jednotky viz soubor my_proc.pas
           }
