program Winograd;
uses crt,matice;
(* prepsat na proceduru a zaclenit do programove jednotky matice 
   nasledne demonstrovat funkci v nejakem programu
*)

(* soucin matic x(2n,2n) a y(2n,2n) podle Winogradovy metody               *)
(* pro vsechna i,j = 1..2n plati :					   *)
(* Sum(k=1,2n) x[i,k] * y[k,j] =					   *)
(*      Sum(k=1,n) (x[i,2k] + y[2k-1,j]) * (x[i,2k-1] + y[2k,j])  vektor u *)
(*    - Sum(k=1,n) (x[i,2k] * x[i,2k-1])                          vektor m *)
(*    - Sum(k=1,n) (y[2k,j] * y[2k-1,j])                          vektor p *)

(* ve vysledku odecitam pro jednotlive prvky u[i,j] 			   *)
(* 	- nejdrive hodnoty vektoru m[i]					   *)
(* 	- nasledne hodnoty vektoru p[j]					   *)
(* dle schematu	:							   *)
(* [U - M - P]                                                             *)
(*    -----------------------------------------------------------------    *)
(*     u11  u12  ...  m1          z11 = u11 - m1   z12 = u12 - m1          *)
(*     u21  u22  ...  m2          z21 = u21 - m2   z22 = u22 - m2          *)
(*      .    .              =>      .   .   .   .   .   .   .              *)
(*      p1   p2                   z11 = z11 - p1   z21 = z21 - p1          *)
(*                                z12 = z12 - p2   z22 = z22 - p2          *)
(*    -----------------------------------------------------------------    *)

(* vysledna slozitost :
 	2n * ( n + 2n*n ) + ( 2n * ( n + 2n ) ) =
	2n^2 + 4n^3 + 2n^2 + 4n^2 		=
	8n^2 + 4n^3				=
	4n^2 * ( 2 + n )    <     4n^2 * ( 2n ) = (2n)^3 - slozitost klasickeho nasobeni
*)

const maxdim=20;
type  rozsah=1..maxdim;
      matice=array[rozsah, rozsah] of integer;

procedure CtiMatici(var mat: matice; n:rozsah);
var i,j:rozsah;
begin for i:=1 to n do
       for j:=1 to n do
{          mat[i,j]:=random(20);        }
           read(mat[i,j]);
end;

procedure PisMatici(var mat: matice; n:rozsah);
var i,j:rozsah;
begin for i:=1 to n do
      begin for j:=1 to n do write(mat[i,j]:4);
            writeln;
      end;
end;

var x,y,z :matice;
    u,m,p:integer;
    i,j,k,n:rozsah;
    nkrat2:integer;

begin Randomize;
 TextAttr:=58;                                (* nastaveni barev prostredi *)
 ClrScr;                                                (* vymaz obrazovky *)
 repeat
  repeat write(' Zadej rad matic (sude cislo, nula konci) : ');
         readln(nkrat2);
  until (not odd(nkrat2));
  if nkrat2<>0 then
  begin n:=nkrat2 div 2;
    writeln(' Zadej hodnoty 1. matice radu ',nkrat2:2); write('   ');
    CtiMatici(x,nkrat2); writeln(' matice ma tvar : ');
    PisMatici(x,nkrat2);
    writeln(' Zadej hodnoty 2. matice radu ',nkrat2:2); write('   ');
    Ctimatici(y,nkrat2); writeln(' matice ma tvar : ');
    PisMatici(y,nkrat2);
    for i:=1 to nkrat2 do
      begin m:=0;
	(* aplikace vzorce pro vektor m pro radky                         *)

        for j:=1 to nkrat2 do
          begin u:=0;

	    (* aplikace vzorce pro vektor u                               *)
	    (* a pro odecet u-m do vyslednych promennych z[i,j]		  *)
	
          end;
      end;

    for j:=1 to nkrat2 do
      begin p:=0;
 
	(* aplikace vzorce pro vektor p pro sloupce                       *)

	(* a pro odecet u-p do vyslednych promennych z[i,j]		  *)

      end;
    writeln(' Vysledna matice je ');
    PisMatici(z,nkrat2);
  end;
 until nkrat2=0;

end.