
 Tema : prace se soubory
 =========================
 soubor - je cokoli, co ma na disku jmeno

 z hlediska pascalu dva typy :
 - soubor znaku = textovy soubor - deklarovany jako "text"
                                 - lze jej editovat a rozumne si jej precist
 - typovy soubor - deklarovany jako "file of typ_souboru"
                 - pri editovani zmet znaku bez vyznamu

 zakladni prikazy pro praci se soubory :
 ---------------------------------------

 * assign = potkam-li ucence, nevzdelanci, pozdravim
          => nez zacnu s nejakym souborem pracovat, musim prislusne promenne
             typu soubor (typovy nebo textovy) pridelit konkretni soubor na
             disku - pokud takovy soubor jeste neexistuje nasledujici prikazy
                     jej musi vytvorit
 * reset = vsechny soubory v pascalu jsou proti zvedavcum chraneny dobrym
           kouzelnikem, zvedavy ucenec pred nahlednutim dovnitr musi pronest
           zaklinaci formuli => - textove soubory otevira pouze pro cteni
                                - typove pro zapis i cteni
 * rewrite = vytvari noveho ucence
           - na disku vytvori novy soubor prislusneho typu a otevre jej
             pro zapis
             !!! pozor - rewrite na existujici soubor tento vymazava !!!
             !!!         a vytvari novy stejneho jmena               !!!

 * write, read - zapis, cteni polozky/znaku do, ze souboru

 * append - otevira textovy soubor pro zapis, aniz by jej smazal
            a nastavuje ukazatel zapisu dalsiho znaku na konec souboru

 * close = kazdy slusny clovek pri odchodu aspon pozdravi
           => zavira otevreny soubor

 * IOResult - interni funkce kontrolujici, zda neprosel ucenec
              => vraci vysledek posledne provedene vstup/vystupni operace
                 0 - prosel ucenec - v/v operace v poradku
                 cislo - prosel buran
            - spolu s direktivou prekladace $I
              (zakazuje {$I-} nebo povoluje {$I+} generovani kodu v/v operace)
              se vyuziva pro testovani existence souboru na disku
              => pri nastaveni {$I+} a chybne provedene v/v operaci (typicky pokus
                 o otevreni neexistujiciho souboru pro cteni) dojde
                 k preruseni programu a generovani runtime errors
              => po provedeni posloupnosti prikazu

                 write(' zadej jmeno souboru s nimz budes pracovat : ');
                 read(jmeno_souboru);
                 {$I-}; assign(S,jmeno_souboru); reset(S); close(S); {$I+};

                 se mohu zeptat, zda neprosel ucenec

                 if IOResult=0 then write('soubor existuje')
                               else write('soubor neexistuje');

                 a kdyz neprosel ucenec, program mi nezhavaruje  :-)

            - pouziti viz unita getfile.pas

 * filesize, filepos, seek
            - v typovem souboru monitoruje a ridi pohyb ucence
            => v typovem souboru se mohu pohybovat po jednotlivych polozkach
               vcetne zjisteni aktualni pozice a velikosti souboru
               nabizi moznosti zmeny - prepisu - prohozeni jednotlivych
               polozek souboru

 * Eof, Eoln - booleovske funkce pro zjisteni, zda ucenec dosel konce...
            - Eof - vraci true, pri docteni souboru do konce (typovy i textovy)
            - Eoln - vraci true pri doctenem radku - pouze pro textovy soubor

 * erase, rename
            - prikazy pro zmateni nepritele v pripade ohrozeni ucence
            - erase maze, rename prejmenovava soubor

============================================================================

 priklad za domaci ukol - k zapoctu :-)

 Napiste program, ktery postupne :
 - vygeneruje dva libovolne velke soubory nahodnych, ale vzestupne
   usporadanych cisel; obsah obou souboru soucasne vypise na obrazovku
 - nasledne cisla z techto dvou souboru zatridi usporadane vzestupne
   do souboru tretiho, prvni dva zrusi, treti prejmenuje na prvni
   a tento opet vypise
 ----------------------------------------------------------------------------
 omezujici podminky :
 - zadna slozena podminka prikazu cyklu nebo if nesmi byt slozena
   z vice jak dvou podminek jednoduchych
 - algoritmus nesmi pouzivat prikazu for
 - preferujte postup, kdy algoritmus nedela a ani se nepta na nic zbytecneho
 - prikazy pro generovani, vypis a setrideni souboru budiz procedury
   uvedene v unite

 napoveda
 - !!! predpokladam absolutne fair-play hru !!!
   -- kdo si problem nevyresi alespon z 90% nejdrive sam,
      nabidnutym resenim stejne nebude rozumnet a pohori nejspis u zkousky
 - provedte si algoritmus nejdrive nad polem
 - nad souborem s vyhodou vyuziji booleovskych promennych
 - nejruznejsi mozna reseni viz adresar !-soubor

 co je treba rozmyslet
 - jestli pri prvnim cteni neni nahodou nektery (oba) soubor(y) prazdny
 - nasledne mohu cisla z jednoho souboru cist nekolikrat po sobe
   dokud nenarazim na cislo vetsi, nez je ve druhem souboru nebo jsem
   nedocetl do konce prvniho souboru
 - pozor na moment, kdy jsem nacetl posledni cislo z jednoho souboru,
   ale toto cislo neni jeste zapsano do souboru tretiho, protoze je az za
   radou cisel (pripadne az na konci) ze souboru jeste nedocteneho
   -- treba rozmyslet nejruznejsi stavy pri docteni jednoho souboru
 - obecne v kazdem predchozim kroku posloupnost prikazu nacteni cisla
   ze souboru a zapis do souboru tretiho nemusi nasledovat po sobe
 - po docteni jednoho souboru zbude jeste druhy, jen jej zkopiruji


============================================================================

 namety pro samostatna reseni
 - roztahnout/omezit pocet znaku na radku na predem zvolenou konstantu
 - vyznacit v danem souboru vybrana slova, znaky, retezce...
 - kryptograficka problematika
   -- dle zvoleneho kodu zasifrovat a nasledne desifrovat obsah textu
 - vypsat / postupne prohlednout obsah daneho souboru
 - porovnat obsah dvou souboru a vyznacit zmeny

 napoveda viz adresar soubor a priklady v nem uvedene...


            hodne zdaru - ucenec, ktery si hraje, nezlobi :-) !