
{ ======================================================================
   DYNAMICKE SEZNAMY - ZASOBNIK
  ======================================================================

   datove struktury - promenne typu record s polozkou ukazatel
   'ukazujici' na dalsi prvek - promennou datove struktury
   - v programu si pamatuji pouze ukazatel na prvni prvek
   - specialni tvary : zasobnik, fronta

deklarace :

type zasobnik = ^prvek ;
       prvek  = record cislo : byte;      (* udava hodnoty prvku zasobniku *)
                       dalsi : zasobnik;(* zajistuje pospojovani struktury *)
                end;
var vrch, pom : zasobnik;

                            !!! poznamka !!! :
  - pouziti identifikatoru prvek - pro oznaceni domenoveho typu v popisu
    typu ukazatel je jedinou vyjimkou z pravidla, ze kazdy identifikator musi
    byt nejprve definovan a teprve potom muze byt pouzit


   ZASOBNIK
   - zakladni dynamicka datova struktura - LIFO - Last In First Out
   - spojovy seznam dyn.promennych typu record
   - ukazatel na vrchol zasobniku = naposledy ulozena dyn.promenna
             1      2      3
    nil <--- * <--- * <--- * <--- vrch

tvorba jednoducheho zasobniku pomoci spojoveho seznamu :

jednotlive prikazy :

begin vrch:=nil;
      new(pom);             -  uvodni prikazy;  nastava tato situace :

      vrch  --------> nil
       pom  --------> (0,nil)
        |                |                        => dalsi prikazy :
      ukazatel        misto v pameti

=>    pom^.cislo:=1;    (* prirazeni hodnoty polozce dyn.prom. typu record *)
                                                   (* - podobne jako p^:=4 *)
      pom^.dalsi:=vrch;        (* pom je ukazatel na dyn.prom typu record; *)
                                       (* jeji polozky jsou cislo a dalsi; *)
                (* dalsi je opet ukazatel stejneho typu jako vrch nebo pom *)
      vrch:=pom;               (* nastaveni cela na posledne ulozeny prvek *)


  momentalni situace :

      vrch,pom -----> (1,dalsi) --> nil                 ... atd. v cyklu :


             1      2      3      new(pom) => pom^.cislo:=4
=>  nil <--- * <--- * <--- * <--- vrch        pom^.dalsi:=vrch <-- vrch:=pom;


z techto prikazu plynou dve procedury
pro inicializaci zasobniku
a ulozeni prvku na vrchol, ktere by mohly mit priblizne tyto hlavicky :

procedure Init_Zasobnik(var vrch : zasobnik);
a
procedure Uloz_Vrch(var vrch : zasobnik);
var pom : seznam;  (* tato hlavicka by mela obsahovat jeste jeden parametr,
                      jaky ? *)

 ==================  konec teorie  =========================================
}

(* prikazy pro praci se zasobnikem s ponekud jednodussimi deklaracemi *)

type  z = ^t;
      t = record x : byte;
                 d : z;
          end;
var pp,dz : z;
begin randomize;

   dz:=nil;                            (* inicializace zasobniku - vrcholu *)
   repeat new(pp);                              (* alokovani nove dyn.prom *)
          pp^.x:=random(20);                  (* prirazeni nahodne hodnoty *)
          pp^.d:=dz;                       (* napojeni na vrchol zasobniku *)
          dz:=pp;        (* nastaveni vrcholu zasobniku na nove vytvorenou *)
                                                    (* dynamickou promenou *)
   until pp^.x=19;      (* vymyslene ukonceni cyklu - nebo libovolne jinak *)

(* obecne si mohu na jednotlive prvky takto budovaneho zasobniku
   primo sahnout takto (vypiste si jednotlive promenne v okne watches)

              dz^
  dz ------>  x   = dz^.x        dz^.d^
              d   = dz^.d ---->  x   =  dz^.d^.x       dz^.d^.d^
                                 d   =  dz^.d^.d --->  x  = dz^.d^.d^.x
                                                       d  = dz^.d^.d^.d
  ukazatel    vrchol zasobniku   prvek tesne
  na vrchol   ma slozky x a d    za vrcholem           a tak dal.......

  ------------------------------------------------------------------------
*)

(* -----    tisk nahodneho seznamu-zasobniku bez uvolneni pameti   ------- *)
   writeln(' vypis zasobniku : ');;
   pp:=dz;  (* nastaveni ukazatele na vrchol zasobniku do pomocne promenne *)
         (* abychom nestratili pristup k vrcholu zasobniku pro dalsi praci *)

   repeat write(pp^.x:5);              (* tisk hodnoty z vrcholu zasobniku *)
          pp:=pp^.d;    (* posunuti ukazatele na pomyslny vrchol zasobniku *)
   until pp=nil;                                 (* konec dle inicializace *)
   writeln;

(* -----    tisk nahodneho seznamu-zasobniku s uvolnenim pameti    ------- *)

   writeln(' uvolneni pameti : ');
   repeat pp:=dz; write(pp^.x:5); dz:=dz^.d; dispose(pp);
   until dz=nil;
   writeln;
end.

(* misto postupneho dispose(ukazatel) lze pouzit nasledujici dve procedury *)
(* mark(adrheap);    - zaznamena stavajici adresu hromady pro ukladani     *)
(*                     dynamickych promenych - oboje viz help              *)
(* release(adrheap); - uvolni vsechny alokovane promene od adresy adrheap  *)
(* kde deklarace vypada takto                                              *)
(* adrheap : pointer;                                                      *)

(* ======================================================================= *)
(*** UKOL   UKOL   UKOL   UKOL   UKOL   UKOL   UKOL   UKOL   UKOL   UKOL ***)
(*   napsat unitu pro zasobnik s jednotlivymi procedurami tak,aby fungoval *)
(*   nasledujici program, tzn dopsat nasledujici procedury :               *)
(*   - inicializaci zasobniku                                              *)
(*   - ulozeni prvku na vrchol zasobniku                                   *)
(*   - odebrani prvku z vrcholu zasobniku                	           *)
(*   - vyhledani prvku v zasobniku                                         *)
(*   - tisk-vypis prvku zasobniku                                          *)
(*   - test na prazdnost zasobniku                                         *)
(* ----------------------------------------------------------------------- *)
{
          program zasobnik;
          type ...
          var ...
          begin Init(zas);
                repeat read(prvek); Uloz(prvek,zas);     (* nacte prvky do *)
                until neco;                                   (* zasobniku *)
                Tisk(zas);      (* vytiskne prvky ze zasobniku bez zruseni *)
                repeat Odeber(prvek,zas);      (* zrusi-vyprazdni zasobnik *)
                       write(' rusim prvek zasobniku s cislem : ',prvek);
                until PrazdnyZ(zas);      (* test na vyprazdneni zasobniku *)
                writeln(' zasobnik je prazdny => dz=nil ');
                readln;
          end.
procedure odeber (var dz : z; var prvek : t);
(* mozna deklarace hlavicky procedury pro odebrani prvku z vrcholu zasobniku *)
begin
end;


(* ----------------------------------------------------------------------- *)
(* demonstracni poslopnost prikazu pro zobrazeni velikosti pameti          *)
(* alokovane pro deklarovane dynamicke promene                             *)
(* ----------------------------------------------------------------------- *)

uses crt;
var pom : longint;
      p : ^byte;
begin
 writeln;
 pom:=MemAvail;                                       (* funkce - viz help *)
 writeln(' velikost souctu bytu vsech volnych bloku pameti v hromade je : ',pom);
 new(p);           (* alokuje v pameti misto pro novou dynamickou promenou *)
          (* deklarovaneho typu a do ukazatele p ulozi adresu tohoto mista *)
 writeln(' dynamicka promenna p^ zabira                            : ',
           pom-MemAvail,' bitu pameti');
 writeln(' momentalni velikost dostupne pameti je                  : ',
           memavail);
 dispose(p);       (* alokovane misto v pameti se uvolni - znovuzpristupni *)
           (* hodnoty zustavaji, ale mohou se kdykoli bez varovani prepsat *)
                                   (* oficialne prestavaji byt deklarovane *)
 writeln(' a po uvolneni pameti                                    : ',
           memavail);

 writeln;
 write(' konec press key '); pom:=longint(readkey);

end.
}