
       NAMET CVICENI - VYHODNOCOVANI ARITMETICKEHO VYRAZU 
                       APLIKACE NA VYUZITI ZASOBNIKU 
       --------------------------------------------------

 1. aplikace na zasobnik 
    - napiste program pro vyhodnoceni algebraickeho vyrazu
    - program zahrnuje dve "faze"
      -- prevod vstupniho retezce reprezentujiciho algebraicky vyraz zapsany
         ve standardnim formatu - tzv. infixu - na postfix
      -- vyhodnoceni vyrazu zapsaneho/prevedeneho do postfixu
    - prevod "infixu" na "postfix" je vhodne dale rozlisit 
      na algebraicke vyrazy vyuzivajici priority operatoru 
      -- napriklad : (8-3)/5*(4+3)
      a na vyrazy s "plnym uzavorkovanim" 
      -- napriklad : (((8-3)/5)*(4+3))

    - inspirace - nabidnute soubory a slovni popis algoritmu
      -- soubor spocti.pas nabizi kostru pro vyhodnoceni postfixu
    - v programech vyuzivejte procedury a fce z Vami naprogramovane unity
      pro praci se zasobnikem	
    - procedury na vyhodnoceni aritmetickeho vyrazu je vhodne implementovat 
      pro toto rozliseni
        - procedura pro prepis infixu na postfix bez zohledneni priority operatoru
          -- na vstupu je plne a korektne uzavorkovany vyraz
          -- vyhodnoceni spravnosti uzavorkovani vyrazu lze prenechat zvlastni 
             booleovske funkci
        - procedura pro prepis infixu na postfix se zohlednenim priority operatoru
          -- pripadny test na korektnost zapisu opet do zvlastni funkce.
        - procedura pro vyhodnoceni postfixu
        (lze vsak vse napsat jako jedinou proceduru provadejici prepis i 
         vyhodnoceni v jedinem cyklu - vlastni realizace dle osobniho uvazeni)
=============================================================================
- slovni popis algoritmu pro prepis _PLNE_ uzavorkovaneho vyrazu (bez vyznamu 
  priority operatoru) z infixu do postfixu pomoci zasobniku
- na zasobnik se ukladaji znaky - char :
- kostra programu pro inspiraci viz soubor spocti.pas
-----------------------------------------------------------------------------
  * program nacte zadany retezec - infix - jako promennou string
  * program probira infix zleva doprava znak po znaku :
    - leve zavorky se ignoruji
    - cisla se zapisuji do promenne postfix
    - operatory se ukladaji na zasobnik
    - precte-li se prava zavorka,
      -- odebere se ze zasobniku jeden prvek a zapise se do promenne postfix
      -- zavorka se nikam neuklada
  * pokud byl vstupni retezec korektne zadan, je s posledni prectenou pravou
    zavorkou soucasne vyprazdnen zasobnik
  * v promenne postfix je vysledek - vyraz v postfixu
-----------------------------------------------------------------------------
   priklad infixoveho zapisu s uzarkovanim  -       ((7 + (4 * (3 - 1))) / 3)
   stejny vyraz v postfixove notaci -                7 4 3 1 - * + 3 /
   vyhodnocen jako 5
   ---
   stav postfixu pri cteni prvni prave zavorky       7 4 3 1
   stav zasobniku pri cteni prvni prave zavorky      + * -
   (hned za jednickou)

=============================================================================
- velmi strucny popis - zvyrazneni rozdilu - algoritmu pro prepis 
  infix -> postfix se zohlednenim priority operatoru
- podrobne viz soubor in-post.pas
-----------------------------------------------------------------------------
  * na zasobnik se ukladaji vsechny neciselne znaky infixu krom prave zavorky
  * jednotlive operatory ukladane na zasobnik maji prioritu odpovidajici jejich 
    algebraicke priorite v aritmetickem vyrazu (  '^' > '/' > '+' > '('  )
  * leva zavorka se uklada automaticky a tvori tzv. "relativni dno" zasobniku 
  * jednotlive operatory se na zasobnik ukladaji se vzestupnou prioritou;
    => operator na vstupu odebira z vrcholu zasobniku vsechny prvky s prioritou 
       vyssi nebo stejnou - rozmyslete, jaky vliv ma toto "rovna se" pri testu 
                            priority operatoru na vstupu a na vrcholu zasobniku 
                            na vlastni vyhodnoceni vyrazu
  * => vsechny znaky v zasobniku ulozene mezi dvema levymi zavorkami maji odspodu 
       vzestupnou prioritu
  * precteni prave zavorky z infixu je popudem k prepisu vsech znaku ze zasobniku 
    az po prvni relativni dno
-----------------------------------------------------------------------------
   priklad stejneho infixoveho zapisu se zohlednenim priority operatoru
						     7 + 4 * (3 - 1) / 3
   stejny vyraz v postfixove notaci -                7 4 3 1 - * 3 / +         (1)
     vyhodnocovan dale jako        7 + (4*2)/3 = 9,666...
   ale spravne by mohlo byt i takto -                7 4 3 1 - 3 / * +         (2)
     vyhodnocovan dale jako        7 + 4*(2/3) = 9,666...
   - viz bod na rozmyslenou ohledne podminky pro test priority ukladaneho prvku
     vzhledem k priorite prvku na vrcholu zasobniku
   ---
   stav postfixu pri cteni prvni prave zavorky       7 4 3 1
   stav zasobniku pri cteni prvni prave zavorky      + * ( -
   (hned za jednickou)

=============================================================================
- slovni popis algoritmu na vyhodnoceni postfixu pomoci zasobniku :
  ( predpoklada pouziti pouze binarnich operatoru ) :
- na zasobnik se ukladaji cisla :
-----------------------------------------------------------------------------
  * ctu postfix zleva doprava znak po znaku
  * prectu-li cislo - ulozim jej do zasobniku
  * prectu-li operator
    - vyberu z vrcholu zasobniku postupne dva ulozene prvky-cisla
      (do dvou promennych)
    - aplikuji na tyto promenne precteny operator
    - vysledek ulozim na vrchol zasobniku
  * pri korektnim zapisu postfixu je po precteni posledniho znaku postfixu
    v zasobniku jeden prvek - vysledek
------------------------------------------------------------------------------
  priklad vyhodnoceni postfixu (1)                    7 4 3 1 - * 3 / +         
  postupny vyvoj zasobniku                            7
  :                                                   7 4 
  :                                                   7 4 3
  :                                                   7 4 3 1
  :                                                   7 4 2
  :                                                   7 8
  :                                                   7 8 3
  az po precteni operatoru / 
  cimz dostanu zasobnik na tvar                       7 2,666... - !!! pozor R-cisla !!!

------------------------------------------------------------------------------
DYNPROC.PAS - nabidka unity s procedurami pro zasobnik, frontu, normalni
              a setrideny seznam => postupne dodelat implementaci
              podobna struktura se bude vyuzivat cely semestr - dynprocX.pas
              - podrobneji viz soubor struktur.pas
 SPOCTI.PAS - nabidnuta kostra pro vyhodnoceni vyrazu v postfixu
              ulozeneho v souboru POSTFIX.DTA
IN-POST.PAS - opet nabidnuta slovni kostra pro prepis infixu do postfixu
              se zohlednenim priority operatoru
            -- doplnte na zaklade tohoto schematu program/proceduru pro 
               celkove vyhodnoceni standartniho aritmetickeho vyrazu v infixu 
	       (priklad se vhodne rozpadne na dve casti - procedury pro :
               - prepis infixu do postfixu se zohlednenim priority operatoru
               - naslene vyhodnoceni postfixu)
